package com.smcic.api.conference.controller;


import com.smcic.api.conference.entity.ConferenceAgendaDetail;
import com.smcic.api.conference.service.impl.ConferenceAgendaDetailServiceImpl;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2024-03-28
 */
@RestController
@RequestMapping("/conference/agenda-detail")
public class ConferenceAgendaDetailController {

    @Resource
    private ConferenceAgendaDetailServiceImpl conferenceAgendaDetailService;

    @PostMapping("create")
    public ConferenceAgendaDetail create(@RequestBody ConferenceAgendaDetail conferenceAgendaDetail){
        conferenceAgendaDetailService.save(conferenceAgendaDetail);
        return conferenceAgendaDetail;
    }

    @GetMapping("list/{id}")
    public List<ConferenceAgendaDetail> list(@PathVariable("id") Long id){
        return conferenceAgendaDetailService.lambdaQuery().eq(ConferenceAgendaDetail::getAgendaId, id).orderByAsc(ConferenceAgendaDetail::getStartTime).list();
    }

}
