package com.smcic.api.conference.controller;


import com.smcic.api.conference.entity.Conference;
import com.smcic.api.conference.service.impl.ConferenceServiceImpl;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2024-03-27
 */
@RestController
@RequestMapping("/conference/conference")
public class ConferenceController {

    @Resource
    private ConferenceServiceImpl conferenceService;

    @PostMapping("create")
    public Conference create(@RequestBody Conference conference){
        conferenceService.save(conference);
        return conference;
    }

    @GetMapping("list")
    public List<Conference> list(){
        return conferenceService.list();
    }

    @GetMapping("info/{id}")
    public Conference info(@PathVariable( "id" ) Long id){
        return conferenceService.getById(id);
    }


    @PostMapping("upload")
    public List<String> upload(@RequestParam("file") MultipartFile file,
                         @RequestParam("id") Long conferenceId){
        return Collections.singletonList(conferenceService.upload(file, conferenceId));
    }

    @PostMapping("multi-upload")
    public List<String> MultiUpload(@RequestParam("files") MultipartFile[] files,
                         @RequestParam("id") Long conferenceId){
        return conferenceService.multiUpload(files, conferenceId);
    }

}
