package com.smcic.api.conference.service.impl;

import com.smcic.api.conference.entity.ConferenceGuest;
import com.smcic.api.conference.mapper.ConferenceGuestMapper;
import com.smcic.api.conference.service.IConferenceGuestService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2024-03-27
 */
@Service
public class ConferenceGuestServiceImpl extends ServiceImpl<ConferenceGuestMapper, ConferenceGuest> implements IConferenceGuestService {

    public List<ConferenceGuest> listByType(Long cid,  Integer type) {
        return lambdaQuery().eq(ConferenceGuest::getConferenceId, cid).eq(type > 0, ConferenceGuest::getUserType, type)
                .orderByAsc(ConferenceGuest::getSortNumber).list();
    }
}
