package com.smcic.api.conference.service.impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.smcic.api.conference.entity.ConferenceNews;
import com.smcic.api.conference.mapper.ConferenceNewsMapper;
import com.smcic.api.conference.service.IConferenceNewsService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2024-03-27
 */
@Service
public class ConferenceNewsServiceImpl extends ServiceImpl<ConferenceNewsMapper, ConferenceNews> implements IConferenceNewsService {


    public Page<ConferenceNews> newsPage(Long cid, Integer page, Integer pageSize, String category) {
        Page<ConferenceNews> newsPage = new Page<>(page, pageSize);
        LambdaQueryWrapper<ConferenceNews> wrapper = new LambdaQueryWrapper<>();

        return baseMapper.selectPage(
                newsPage,
                wrapper.eq(ConferenceNews::getConferenceId, cid)
                        .eq(ConferenceNews::getCategory, category)
                        .orderByDesc(Arrays.asList(ConferenceNews::getIsTop, ConferenceNews::getPublishTime))
        );
    }

    public List<ConferenceNews>  newsList(Long cid, String category){
        return lambdaQuery().eq(ConferenceNews::getConferenceId, cid).eq(ConferenceNews::getCategory, category).list();
    }
}
