package com.smcic.api.epg.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.smcic.api.epg.entity.KeywordDisableConfig;
import com.smcic.api.epg.service.impl.KeywordDisableConfigService;
import com.smcic.core.auth.LoginRequired;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping("keywords")
public class KeywordController {

    @Resource
    private KeywordDisableConfigService keywordDisableConfigService;

    @GetMapping("list")
    public IPage<KeywordDisableConfig> list(@Param("channelId") Integer channelId,
                                            @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
                                            @RequestParam(value = "pagesize", required = false, defaultValue = "20") Integer pageSize) {
        return keywordDisableConfigService.keywordConfigList(channelId, page, pageSize);
    }

    @PostMapping("disable")
//    @LoginRequired
    public void disable(@RequestBody KeywordDisableConfig keywordDisableConfig){
        keywordDisableConfigService.disable(keywordDisableConfig);
    }

    @PostMapping("update")
//    @LoginRequired
    public void update(@RequestBody KeywordDisableConfig keywordDisableConfig){
        keywordDisableConfigService.update(keywordDisableConfig);
    }

}
